#include <algorithm>

template<typename T>
class c_array {
public:
private:
    T*  array;
    unsigned int array_size;

    bool cleanup;

public:
    /* Helper to ge the const char* of a string */
    static const char* const_cpp2cstr(const std::string& s) { return s.c_str(); }
    // TODO: hier entsteht ein memleak
    static char* cpp2cstr(std::string& s) { char* foo = new char[s.size()+1]; sprintf(foo, s.c_str() ); return foo; }

    /* Construtor */
    template<typename C>
        c_array(const C& container) {
	    cleanup = false;
            array = new T[array_size=container.size()];
            std::transform(container.begin(),
                           container.end(),
                           array,
                           &c_array::const_cpp2cstr);
        }

    template<typename C>
        c_array(C& container) {
            cleanup = true;
            array = new T[array_size=container.size()];
            std::transform(container.begin(),
                           container.end(),
                           array,
                           &c_array::cpp2cstr);
        }


    /* Destructor. */
    ~c_array() { 
		if (cleanup) {
			for (unsigned int i=0; i<array_size; i++)
				delete[] array[i];
		}
		delete[] array; 
	}

    /* Getter */
    const T* const_get() const { return array; }
    
    T* get() const { return array; }

    
    /* Get size. */
    unsigned int size() const { return array_size; }



};

template<typename T> std::ostream& operator<<(std::ostream & out, c_array<T>& carray) {
		for (unsigned int i = 0; i<carray.size(); i++) {
                	out << carray.get()[i];
			if (i+1<carray.size())
				out << " ";
		}

                return out;
}


